JUCE: AccessibilityHandler Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
AccessibilityHandler Class Reference
juce_gui_basics » accessibility

Base class for accessible Components. More...

`#include <juce_AccessibilityHandler.h>`

Inherited by juce::detail::ButtonAccessibilityHandler.

## Classes
struct | Interfaces
| Utility struct which holds one or more accessibility interfaces. More...

## Public Types
enum class | AnnouncementPriority { low , medium , high }
| A priority level that can help an accessibility client determine how to handle an announcement request. More...

## Public Member Functions
| AccessibilityHandler (Component &componentToWrap, AccessibilityRole accessibilityRole, AccessibilityActions actions={}, Interfaces interfaces={})
| Constructor.
virtual | ~AccessibilityHandler ()
| Destructor.
const Component & | getComponent () const noexcept
| Returns the Component that this handler represents.
Component & | getComponent () noexcept
| Returns the Component that this handler represents.
AccessibilityRole | getRole () const noexcept
| The type of UI element that this accessibility handler represents.
virtual String | getTitle () const
| The title of the UI element.
virtual String | getDescription () const
| A short description of the UI element.
virtual String | getHelp () const
| Some help text for the UI element (if required).
virtual AccessibleState | getCurrentState () const
| Returns the current state of the UI element.
bool | isIgnored () const
| Returns true if this UI element should be ignored by accessibility clients.
bool | isVisibleWithinParent () const
| Returns true if this UI element is visible within its parent.
const AccessibilityActions & | getActions () const noexcept
| Returns the set of actions that the UI element supports and the associated callbacks.
AccessibilityValueInterface * | getValueInterface () const
| Returns the value interface for this UI element, or nullptr if it is not supported.
AccessibilityTableInterface * | getTableInterface () const
| Returns the table interface for this UI element, or nullptr if it is not supported.
AccessibilityCellInterface * | getCellInterface () const
| Returns the cell interface for this UI element, or nullptr if it is not supported.
AccessibilityTextInterface * | getTextInterface () const
| Returns the text interface for this UI element, or nullptr if it is not supported.
AccessibilityHandler * | getParent () const
| Returns the first unignored parent of this UI element in the accessibility hierarchy, or nullptr if this is a root element without a parent.
std::vector< AccessibilityHandler * > | getChildren () const
| Returns the unignored children of this UI element in the accessibility hierarchy.
bool | isParentOf (const AccessibilityHandler *possibleChild) const noexcept
| Checks whether a given UI element is a child of this one in the accessibility hierarchy.
AccessibilityHandler * | getChildAt (Point< int > screenPoint)
| Returns the deepest child of this UI element in the accessibility hierarchy that contains the given screen point, or nullptr if there is no child at this point.
AccessibilityHandler * | getChildFocus ()
| Returns the deepest UI element which currently has focus.
bool | hasFocus (bool trueIfChildFocused) const
| Returns true if this UI element has the focus.
void | grabFocus ()
| Tries to give focus to this UI element.
void | giveAwayFocus () const
| If this UI element or any of its children in the accessibility hierarchy currently have focus, this will defocus it.
void | notifyAccessibilityEvent (AccessibilityEvent event) const
| Used to send a notification to any observing accessibility clients that something has changed in the UI element.
AccessibilityNativeHandle * | getNativeImplementation () const
std::type_index | getTypeIndex () const

## Static Public Member Functions
static void | postAnnouncement (const String &announcementString, AnnouncementPriority priority)
| Posts an announcement to be made to the user.
static void | clearCurrentlyFocusedHandler ()
static void * | getNativeChildForComponent (Component &component)
static void | setNativeChildForComponent (Component &component, void *nativeChild)
static Component * | getComponentForNativeChild (void *nativeChild)

## Detailed Description

Base class for accessible Components.

This class wraps a Component and provides methods that allow an accessibility client, such as VoiceOver on macOS, or Narrator on Windows, to control it.

It handles hierarchical navigation, properties, state, and various interfaces.

## Member Enumeration Documentation

## ◆ AnnouncementPriority

enum class AccessibilityHandler::AnnouncementPriority
| strong

A priority level that can help an accessibility client determine how to handle an announcement request.

Exactly what this controls is platform-specific, but generally a low priority announcement will be read when the screen reader is free, whereas a high priority announcement will interrupt the current speech.

Enumerator
low |
medium |
high |

## Constructor & Destructor Documentation

## ◆ AccessibilityHandler()

AccessibilityHandler::AccessibilityHandler | ( | Component & | componentToWrap,
|  | AccessibilityRole | accessibilityRole,
|  | AccessibilityActions | actions = `{}`,
|  | Interfaces | interfaces = `{}`
| ) |  |

Constructor.

This will create a AccessibilityHandler which wraps the provided Component and makes it visible to accessibility clients. You must also specify a role for the UI element from the `AccessibilityRole` list which best describes it.

To enable users to interact with the UI element you should provide the set of supported actions and their associated callbacks via the `accessibilityActions` parameter.

For UI elements that support more complex interaction the value, text, table, and cell interfaces should be implemented as required and passed as the final argument of this constructor. See the documentation of these classes for more information about the types of control they represent and which methods need to be implemented.

## ◆ ~AccessibilityHandler()

virtual AccessibilityHandler::~AccessibilityHandler | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getComponent() [1/2]

const Component & AccessibilityHandler::getComponent | ( |  | ) | const
| noexcept

Returns the Component that this handler represents.

## ◆ getComponent() [2/2]

Component & AccessibilityHandler::getComponent | ( |  | ) |
| noexcept

Returns the Component that this handler represents.

## ◆ getRole()

AccessibilityRole AccessibilityHandler::getRole | ( |  | ) | const
| noexcept

The type of UI element that this accessibility handler represents.

See also
  AccessibilityRole

## ◆ getTitle()

virtual String AccessibilityHandler::getTitle | ( |  | ) | const
| virtual

The title of the UI element.

This will be read out by the system and should be concise, preferably matching the visible title of the UI element (if any). For example, this might be the text of a button or a simple label.

The default implementation will call `Component::getTitle()`, but you can override this to return a different string if required.

If neither a name nor a description is provided then the UI element may be ignored by accessibility clients.

This must be a localised string.

## ◆ getDescription()

virtual String AccessibilityHandler::getDescription | ( |  | ) | const
| virtual

A short description of the UI element.

This may be read out by the system. It should not include the type of the UI element and should ideally be a single word, for example "Open" for a button that opens a window.

The default implementation will call `Component::getDescription()`, but you can override this to return a different string if required.

If neither a name nor a description is provided then the UI element may be ignored by accessibility clients.

This must be a localised string.

## ◆ getHelp()

virtual String AccessibilityHandler::getHelp | ( |  | ) | const
| virtual

Some help text for the UI element (if required).

This may be read out by the system. This string functions in a similar way to a tooltip, for example "Click to open window." for a button which opens a window.

The default implementation will call `Component::getHelpText()`, but you can override this to return a different string if required.

This must be a localised string.

## ◆ getCurrentState()

virtual AccessibleState AccessibilityHandler::getCurrentState | ( |  | ) | const
| virtual

Returns the current state of the UI element.

The default implementation of this method will set the focusable flag and, if this UI element is currently focused, will also set the focused flag.

## ◆ isIgnored()

bool AccessibilityHandler::isIgnored | ( |  | ) | const

Returns true if this UI element should be ignored by accessibility clients.

## ◆ isVisibleWithinParent()

bool AccessibilityHandler::isVisibleWithinParent | ( |  | ) | const

Returns true if this UI element is visible within its parent.

This will always return true for UI elements with the AccessibleState::accessibleOffscreen flag set.

## ◆ getActions()

const AccessibilityActions & AccessibilityHandler::getActions | ( |  | ) | const
| noexcept

Returns the set of actions that the UI element supports and the associated callbacks.

## ◆ getValueInterface()

AccessibilityValueInterface * AccessibilityHandler::getValueInterface | ( |  | ) | const

Returns the value interface for this UI element, or nullptr if it is not supported.

See also
  AccessibilityValueInterface

## ◆ getTableInterface()

AccessibilityTableInterface * AccessibilityHandler::getTableInterface | ( |  | ) | const

Returns the table interface for this UI element, or nullptr if it is not supported.

See also
  AccessibilityTableInterface

## ◆ getCellInterface()

AccessibilityCellInterface * AccessibilityHandler::getCellInterface | ( |  | ) | const

Returns the cell interface for this UI element, or nullptr if it is not supported.

See also
  AccessibilityCellInterface

## ◆ getTextInterface()

AccessibilityTextInterface * AccessibilityHandler::getTextInterface | ( |  | ) | const

Returns the text interface for this UI element, or nullptr if it is not supported.

See also
  AccessibilityTextInterface

## ◆ getParent()

AccessibilityHandler * AccessibilityHandler::getParent | ( |  | ) | const

Returns the first unignored parent of this UI element in the accessibility hierarchy, or nullptr if this is a root element without a parent.

## ◆ getChildren()

std::vector< AccessibilityHandler * > AccessibilityHandler::getChildren | ( |  | ) | const

Returns the unignored children of this UI element in the accessibility hierarchy.

## ◆ isParentOf()

bool AccessibilityHandler::isParentOf | ( | const AccessibilityHandler * | possibleChild | ) | const
| noexcept

Checks whether a given UI element is a child of this one in the accessibility hierarchy.

## ◆ getChildAt()

AccessibilityHandler * AccessibilityHandler::getChildAt | ( | Point< int > | screenPoint | ) |

Returns the deepest child of this UI element in the accessibility hierarchy that contains the given screen point, or nullptr if there is no child at this point.

## ◆ getChildFocus()

AccessibilityHandler * AccessibilityHandler::getChildFocus | ( |  | ) |

Returns the deepest UI element which currently has focus.

This can be a child of this UI element or, if no child is focused, this element itself.

Note that this can be different to the value of the Component with keyboard focus returned by Component::getCurrentlyFocusedComponent().

See also
  hasFocus

## ◆ hasFocus()

bool AccessibilityHandler::hasFocus | ( | bool | trueIfChildFocused | ) | const

Returns true if this UI element has the focus.

Parameters

  trueIfChildFocused | if this is true, this method will also return true if any child of this UI element in the accessibility hierarchy has focus

## ◆ grabFocus()

void AccessibilityHandler::grabFocus | ( |  | ) |

Tries to give focus to this UI element.

If the UI element is focusable and not ignored this will update the currently focused element, try to give keyboard focus to the Component it represents, and notify any listening accessibility clients that the current focus has changed.

See also
  hasFocus, giveAwayFocus

## ◆ giveAwayFocus()

void AccessibilityHandler::giveAwayFocus | ( |  | ) | const

If this UI element or any of its children in the accessibility hierarchy currently have focus, this will defocus it.

This will also give away the keyboard focus from the Component it represents, and notify any listening accessibility clients that the current focus has changed.

See also
  hasFocus, grabFocus

## ◆ notifyAccessibilityEvent()

void AccessibilityHandler::notifyAccessibilityEvent | ( | AccessibilityEvent | event | ) | const

Used to send a notification to any observing accessibility clients that something has changed in the UI element.

See also
  AccessibilityEvent

## ◆ postAnnouncement()

static void AccessibilityHandler::postAnnouncement | ( | const String & | announcementString,
|  | AnnouncementPriority | priority
| ) |  |
| static

Posts an announcement to be made to the user.

Parameters

  announcementString | a localised string containing the announcement to be read out
  priority | the appropriate priority level for the announcement

## ◆ getNativeImplementation()

AccessibilityNativeHandle * AccessibilityHandler::getNativeImplementation | ( |  | ) | const

## ◆ getTypeIndex()

std::type_index AccessibilityHandler::getTypeIndex | ( |  | ) | const

## ◆ clearCurrentlyFocusedHandler()

static void AccessibilityHandler::clearCurrentlyFocusedHandler | ( |  | ) |
| static

## ◆ getNativeChildForComponent()

static void * AccessibilityHandler::getNativeChildForComponent | ( | Component & | component | ) |
| static

## ◆ setNativeChildForComponent()

static void AccessibilityHandler::setNativeChildForComponent | ( | Component & | component,
|  | void * | nativeChild
| ) |  |
| static

## ◆ getComponentForNativeChild()

static Component * AccessibilityHandler::getComponentForNativeChild | ( | void * | nativeChild | ) |
| static

The documentation for this class was generated from the following file:

- juce_AccessibilityHandler.h